import java.io.*;
import java.util.*;

public class RotStrng
{
	static StreamTokenizer st = new StreamTokenizer(
		new BufferedReader(new InputStreamReader(System.in)));
	public static void main(String[] args) throws IOException
	{
		st.nextToken(); int T = (int)st.nval;
		while(T-->0)
		{
			st.nextToken(); char[] str = st.sval.toCharArray();
			st.nextToken(); int m = (int)st.nval;
			st.nextToken(); int p = (int)st.nval;
			
			int n = str.length; m %= n; p %= n;
			boolean[] possible = new boolean[n];
			fill(possible, str);
			
			int dist = 1, index = m, next = p;
			while(true)
			{
				if(possible[index])
					break;
				dist++;
				index += next;
				next = next == m ? p : m;
				if(index >= n)
					index -= n;
			}
			System.out.println(dist);
		}
	}
	static void fill(boolean[] possible, char[] str)
	{
		int[] table = kmpTable(str);
		int pos = 0, matched = 0, n = str.length;
		while(pos + matched < 2*n)
		{
			int toMatch = pos + matched;
			while(toMatch>=n) toMatch -= n;
			if(str[matched] == str[toMatch])
			{
				if(matched+1==n)
				{
					possible[pos >= n ? pos-n : pos] = true;
					pos = pos + matched - table[matched];
					matched = table[matched] >= 0 ? table[matched] : 0;
				}
				else
					++matched;
			}
			else
			{
				pos = pos + matched - table[matched];
				matched = table[matched] >= 0 ? table[matched] : 0;
			}
		}
	}
	static int[] kmpTable(char[] str)
	{
		int n = str.length;
		int[] table = new int[n];
		table[0] = -1; table[1] = 0;
		int pos = 2, matched = 0;
		while(pos<n)
		{
			if(str[pos-1] == str[matched])
				table[pos++] = ++matched;
			else if (matched>0)
				matched = table[matched];
			else
				table[pos++] = 0;
		}
		return table;
	}
}
